package ics332.deadlock.a_spinlocks;

/**
 * In this Program
 * 
 * Two threads are created: one {@link Thread12} will try to lock resource 1, and then resource 2, while
 * the other one {@link Thread21} will try to lock resource 2, and then resource 1.
 * 
 * (The run() methods of these threads have been implemented so that a deadlock is intentionally created)
 * 
 * The lock used here are spin locks.
 * 
 * Watch how the CPU resource is wasted waiting for the locks! 
 * (Execute "top -d 1 -H" in a terminal; in top: sort by CPU usage with 'P', quit with 'q') 
 * 
 */
public class ShowDeadlock {
	public static void main(String[] args) {
		Resources resources = new Resources();
		Thread t12 = new Thread12(resources);
		Thread t21 = new Thread21(resources);
		
		t12.start();
		t21.start();
		
		try {
			t12.join();
			t21.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
