package ics332.deadlock.b_blockinglocks;

/**
 * Thread that acquires lock 2 then lock 1 works and release
 * This is an educative example to demonstrate how deadlocks happen
 * 
 * The thread voluntarily is set asleep before trying to acquire 1
 *  
 * Uses a blocking lock
 * 
 */
public class Thread21 extends Thread {
	private Resources resources;

	public Thread21(Resources resources) {
		this.resources = resources;
	}
	
	@Override
	public void run() {
		try {
			System.out.println(Thread21.class.getName() + " running");
			this.resources.lock2.lock();
			System.out.println(Thread21.class.getName() + " lock2 acquired");
			Thread.sleep(10);
			this.resources.lock1.lock();
			System.out.println(Thread21.class.getName() + " lock1 acquired");
			Thread.sleep(10);
			Thread.sleep(1000);
			this.resources.lock1.unlock();
			System.out.println(Thread21.class.getName() + " lock1 released");
			Thread.sleep(10);
			this.resources.lock2.unlock();
			System.out.println(Thread21.class.getName() + " lock2 released");
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
